<?php
/**
 * JS
 * @package     Woocommerce Purolator Small
 * @author      <https://eniture.com/>
 * @copyright   Copyright (c) 2017, Eniture
 */
if (!defined('ABSPATH')) {
    exit;
}

/**
 * Connection Section Fields Validation
 * 
 * Quote Setting Section Fields Validation
 * 
 * Test Connection AJAX 
 */

add_action('admin_footer', 'purolator_small_connection_setting');
/**
 * JS
 */
function purolator_small_connection_setting() {
    ?>
    <script>
        jQuery(document).ready(function () {
            
            jQuery("input[name*='wc_pervent_proceed_checkout_purolator_small']").closest('tr').addClass('wc_pervent_proceed_checkout_purolator_small');
            jQuery(".wc_pervent_proceed_checkout_purolator_small input[value*='allow']").after('Allow user to continue to check out and display this message <br><br><textarea name="allow_proceed_checkout_purolator_small" class="prevent_text_box" title="Message"> <?php echo trim(get_option("allow_proceed_checkout_purolator_small")); ?></textarea>');
            jQuery(".wc_pervent_proceed_checkout_purolator_small input[value*='prevent']").after('Prevent user from checking out and display this message <br><br><textarea name="prevent_proceed_checkout_purolator_small" class="prevent_text_box" title="Message"> <?php echo trim(get_option("prevent_proceed_checkout_purolator_small")); ?></textarea>');
            
            
            var url      = getUrlVarsPurolatorSmall()["tab"];
            if(url === 'purolator_small'){
                jQuery('#footer-left').attr('id','wc-footer-left');
            }
            /*
             * Add Title To Quote Setting Fields
             */

               jQuery( '#purolator_small_hazardous_fee' ).attr('title','Hazardous Material Fee');
               jQuery( '#purolator_small_hand_fee_mark_up' ).attr('title','Handling Fee / Markup');


            /*
            * Add maxlength Attribute on Connection Setting Page
            */    

               jQuery("#purolator_small_registered_state").attr('maxlength','2');
               jQuery("#purolator_small_registered_zip").attr('maxlength','7');
            
            /*
             * Add maxlength Attribute on Handling Fee Quote Setting Page
             */    

                jQuery("#purolator_small_hand_fee_mark_up").attr('maxlength','8');
                jQuery("#purolator_small_hazardous_fee").attr('maxlength','8');

                jQuery('.purolator_small_connection_section input[type="text"]' ).each( function () {
                    if( jQuery( this ).parent().find( '.err' ).length < 1 ){
                        jQuery( this ).after( '<span class="err"></span>' );
                    }  
                });
        
        
            /*
             * Add Title To Connection Setting Fields
             */
             
                jQuery('.purolator_small_connection_section .form-table').before('<div class="notice-warning purolator_small_warning_message"><p><strong>Note! You have a Purolator Small account to use this application. If you do not have one contact Purolator at 800-742-5877 or <a target="_blank" href="https://eshiponline.purolator.com/ShipOnline/SecurePages/Public/Register.aspx">Register Online</a> </strong></p></div>');
                jQuery('#purolator_small_billing_account_number').attr('title', 'Billing Account Number');
                jQuery('#purolator_small_registered_account_number').attr('title', 'Registered Account Number');
                jQuery('#purolator_small_registered_city').attr('title', 'City');
                jQuery('#purolator_small_registered_state').attr('title', 'State');
                jQuery('#purolator_small_registered_zip').attr('title', 'Zip');
                jQuery('#purolator_small_pro_key').attr('title', 'Production Key ');
                jQuery('#purolator_small_pro_key_pass').attr('title', 'Production Key Password ');
                jQuery('#purolator_small_licence_key').attr('title', 'Plugin License Key');


            /*
             * Add CSS Class To Quote Services
             */

                jQuery('.bold-text').closest('tr').addClass('purolator_small_quotes_services_tr');
                jQuery('.purolator_small_quotes_services').closest('tr').addClass('purolator_small_quotes_services_tr');
                jQuery('.purolator_small_quotes_services').closest('td').addClass('purolator_small_quotes_services_td');
                jQuery('.purolator_small_int_quotes_services').closest('tr').addClass('purolator_small_quotes_services_tr');
                jQuery('.purolator_small_int_quotes_services').closest('td').addClass('purolator_small_quotes_services_td');
                jQuery('.purolator_small_ww_quotes_services').closest('tr').addClass('purolator_small_quotes_services_tr');
                jQuery('.purolator_small_ww_quotes_services').closest('td').addClass('purolator_small_quotes_services_td');

            /*
             * Uncheck Select All Checkbox
             */

                jQuery(".purolator_small_domestic_quote_service").on('change load', function () {
                    var checkboxes = jQuery('.purolator_small_domestic_quote_service:checked').size();
                    var un_checkboxes = jQuery('.purolator_small_domestic_quote_service').size();
                    if (checkboxes === un_checkboxes) {
                        jQuery('.purolator_small_all_services').attr('checked', true);
                    } else {
                        jQuery('.purolator_small_all_services').attr('checked', false);
                    }
                });

            /*
             * Uncheck International Services Select All Checkbox
             */

                jQuery(".purolator_small_int_quotes_services").on('change load', function () {
                    var int_checkboxes = jQuery('.purolator_small_int_quotes_services:checked').size();
                    var int_un_checkboxes = jQuery('.purolator_small_int_quotes_services').size();
                    if (int_checkboxes === int_un_checkboxes) {
                        jQuery('.purolator_small_all_int_services').attr('checked', true);
                    } else {
                        jQuery('.purolator_small_all_int_services').attr('checked', false);
                    }
                });

            /*
             * Uncheck world wide Services Select All Checkbox
             */

                jQuery(".purolator_small_ww_quotes_services").on('change load', function () {
                    var int_checkboxes = jQuery('.purolator_small_ww_quotes_services:checked').size();
                    var int_un_checkboxes = jQuery('.purolator_small_ww_quotes_services').size();
                    if (int_checkboxes === int_un_checkboxes) {
                        jQuery('.purolator_small_all_ww_services').attr('checked', true);
                    } else {
                        jQuery('.purolator_small_all_ww_services').attr('checked', false);
                    }
                });

            /*
             * Save Changes Action
             */

                jQuery('.purolator_small_quote_section .button-primary').on('click', function () {
                    jQuery('.error').remove();
                    jQuery('.updated').remove();
                    var num_of_checkboxes = jQuery('.purolator_small_domestic_quote_service:checked').size();
                    var num_of_int_checkboxes = jQuery('.purolator_small_int_quotes_services:checked').size();
                    var num_of_ww_checkboxes = jQuery('.purolator_small_ww_quotes_services:checked').size();
                    var handling_fee = jQuery('#purolator_small_hand_fee_mark_up').val();
                    var hazardous_fee = jQuery('#purolator_small_hazardous_fee').val();
                    var Error = true;

                    /*
                     * Check Number of Selected Services
                     */

                    if (num_of_checkboxes < 1 && num_of_int_checkboxes < 1 && num_of_ww_checkboxes < 1) {
                        no_service_selected_purolator_small(num_of_checkboxes);
                        return false;
                    }

                    /*
                     * Handeling Fee Input Validation
                     */

                    if (handling_fee.slice(handling_fee.length - 1) == '%') {
                        handling_fee = handling_fee.slice(0, handling_fee.length - 1)
                    }

                    if (handling_fee !== "" && isValidNumber(handling_fee) === false) {
                        jQuery("#mainform .purolator_small_quote_section").prepend('<div id="message" class="error inline purolator_small_handlng_fee_error"><p><strong>Handling fee format should be 100.2000 or 10%.</strong></p></div>');
                        jQuery('html, body').animate({
                            'scrollTop': jQuery('.purolator_small_handlng_fee_error').position().top
                        });
                        Error = false;
                    } else if (handling_fee !== "" && isValidNumber(handling_fee) === 'decimal_point_err') {
                        jQuery("#mainform .purolator_small_quote_section").prepend('<div id="message" class="error inline purolator_small_handlng_fee_error"><p><strong>Handling fee format should be 100.2000 or 10% and only 4 digits are allowed after decimal point.</strong></p></div>');
                        jQuery('html, body').animate({
                            'scrollTop': jQuery('.purolator_small_handlng_fee_error').position().top
                        });
                        Error = false;
                    }


                    /*
                     * Hazardous Fee Input Validation
                     */

                    if ((hazardous_fee !== "" && isValidNumber(hazardous_fee) === false) || hazardous_fee < 0) {
                        jQuery("#mainform .purolator_small_quote_section").prepend('<div id="message" class="error inline purolator_small_hzrds_fee_error"><p><strong>Hazardous material fee format should be 100.2000.</strong></p></div> ');
                        jQuery('html, body').animate({
                            'scrollTop': jQuery('.purolator_small_hzrds_fee_error').position().top
                        });
                        Error = false;
                    } else if (hazardous_fee !== "" && isValidNumber(hazardous_fee) === 'decimal_point_err') {
                        jQuery("#mainform .purolator_small_quote_section").prepend('<div id="message" class="error inline purolator_small_hzrds_fee_error"><p><strong>Hazardous material fee format should be 100.2000 and only 4 digits are allowed after decimal point.</strong></p></div>');
                        jQuery('html, body').animate({
                            'scrollTop': jQuery('.purolator_small_hzrds_fee_error').position().top
                        });
                        Error = false;
                    }
                    return Error;
                });

                
            });
            
            /*
                 * Select All Services
                 */

                var sm_all_checkboxes = jQuery('.purolator_small_domestic_quote_service');
                if (sm_all_checkboxes.length === sm_all_checkboxes.filter(":checked").length) {
                    jQuery('.purolator_small_all_services').prop('checked', true);
                }

                jQuery(".purolator_small_all_services").change(function () {
                    if (this.checked) {
                        jQuery(".purolator_small_domestic_quote_service").each(function () {
                            this.checked = true;
                        })
                    } else {
                        jQuery(".purolator_small_domestic_quote_service").each(function () {
                            this.checked = false;
                        })
                    }
                });

        /*
         * Select All Services International
         */

            var all_int_checkboxes = jQuery('.purolator_small_int_quotes_services');
            if (all_int_checkboxes.length === all_int_checkboxes.filter(":checked").length) {
                jQuery('.purolator_small_all_int_services').prop('checked', true);
            }

            jQuery(".purolator_small_all_int_services").change(function () {
                if (this.checked) {
                    jQuery(".purolator_small_int_quotes_services").each(function () {
                        this.checked = true;
                    })
                } else {
                    jQuery(".purolator_small_int_quotes_services").each(function () {
                        this.checked = false;
                    })
                }
            });
        /*
         * Select All World Wide Services International
         */

            var all_int_checkboxes = jQuery('.purolator_small_ww_quotes_services');
            if (all_int_checkboxes.length === all_int_checkboxes.filter(":checked").length) {
                jQuery('.purolator_small_all_ww_services').prop('checked', true);
            }

            jQuery(".purolator_small_all_ww_services").change(function () {
                if (this.checked) {
                    jQuery(".purolator_small_ww_quotes_services").each(function () {
                        this.checked = true;
                    })
                } else {
                    jQuery(".purolator_small_ww_quotes_services").each(function () {
                        this.checked = false;
                    })
                }
            });
        
        /**
        * Read a page's GET URL variables and return them as an associative array.
        */
        function getUrlVarsPurolatorSmall()
        {
            var vars = [], hash;
            var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
            for(var i = 0; i < hashes.length; i++)
            {
                hash = hashes[i].split('=');
                vars.push(hash[0]);
                vars[hash[0]] = hash[1];
            }
            return vars;
        }
        
        /*
         * Validate Selecting Services 
         */

            function no_service_selected_purolator_small(num_of_checkboxes)
            {

                jQuery(".updated").hide();
                jQuery(".purolator_small_quote_section h2:first-child").after('<div id="message" class="error inline no_srvc_select"><p><strong>Please select at least one quote service.</strong></p></div>');
                jQuery('html, body').animate({
                    'scrollTop': jQuery('.no_srvc_select').position().top
                });
                return false;
            }

        /*
         * Validate Input If Empty or Invalid
         */

            function validateInput(form_id)
            {
                var has_err = true;
                jQuery(form_id + " input[type='text']").each(function () {
                    var input = jQuery(this).val();
                    var response = validateString(input);
                    
                    var errorElement = jQuery(this).parent().find('.err');
                    jQuery(errorElement).html('');
                    var errorText = jQuery(this).attr('title');
                    var optional = jQuery(this).data('optional');
                    optional = (optional === undefined) ? 0 : 1;
                    errorText = (errorText != undefined) ? errorText : '';
                    if ((optional == 0) && (response == false || response == 'empty')) {
                        errorText = (response == 'empty') ? errorText + ' is required.' : 'Invalid input.';
                        jQuery(errorElement).html(errorText);
                    }
                    has_err = (response != true && optional == 0) ? false : has_err;
                });
                return has_err;
            }

        /*
         * Check Input Value Is Not String
         */

            function isValidNumber(value, noNegative)
            {
                if (typeof (noNegative) === 'undefined')
                    noNegative = false;
                var isValidNumber = false;
                var validNumber = (noNegative == true) ? parseFloat(value) >= 0 : true;
                if ((value == parseInt(value) || value == parseFloat(value)) && (validNumber)) {
                    if (value.indexOf(".") >= 0) {
                        var n = value.split(".");
                        if (n[n.length - 1].length <= 4) {
                            isValidNumber = true;
                        } else {
                            isValidNumber = 'decimal_point_err';
                        }
                    } else {
                        isValidNumber = true;
                    }
                }
                return isValidNumber;
            }

        /*
         * Validate Input String 
         */

            function validateString(string)
            {
                if (string == '') {
                    return 'empty';
                } else {
                    return true;
                }
            }

        /*
         * Connection Settings Input Validation On Save 
         */

            jQuery(".purolator_small_connection_section .button-primary").click(function ()
            {
                var input = validateInput('.purolator_small_connection_section');
                if (input === false) {
                    return false;
                }
            });

        /*
         * Test Connection 
         */

            jQuery(".purolator_small_connection_section .woocommerce-save-button").before('<a href="javascript:void(0)" class="button-primary purolator_small_test_connection">Test Connection</a>');
            jQuery('.purolator_small_test_connection').click(function (e)
            {
                var input = validateInput('.purolator_small_connection_section');
                if (input === false) {
                    return false;
                }
                var postForm = {
                    'action': 'purolator_small_test_connection',
                    'purolator_small_billing_acc_number': jQuery('#purolator_small_billing_account_number').val(),
                    'purolator_small_registered_acc_number': jQuery('#purolator_small_registered_account_number').val(),
                    'purolator_small_registered_city': jQuery('#purolator_small_registered_city').val(),
                    'purolator_small_registered_state': jQuery('#purolator_small_registered_state').val(),
                    'purolator_small_registered_zip': jQuery('#purolator_small_registered_zip').val(),
                    'purolator_small_pro_key': jQuery('#purolator_small_pro_key').val(),
                    'purolator_small_pro_key_pass': jQuery('#purolator_small_pro_key_pass').val(),
                    'purolator_small_license': jQuery('#purolator_small_licence_key').val(),
                };
                jQuery.ajax({
                    type: 'POST',
                    url: ajaxurl,
                    data: postForm,
                    dataType: 'json',
                    beforeSend: function ()
                    {
                        jQuery('#purolator_small_billing_account_number, #purolator_small_registered_account_number, #purolator_small_registered_city, #purolator_small_registered_state, #purolator_small_registered_zip, #purolator_small_pro_key, #purolator_small_pro_key_pass, #purolator_small_licence_key').addClass('purolator_small_test_conn_prosessing');
                    },

                    success: function (data)
                    {
                        if (data['Error']) {

                            jQuery(".updated").hide();
                            jQuery(".purolator_small_error_message").remove();
                            jQuery(".purolator_small_success_message").remove();
                            jQuery('#purolator_small_billing_account_number, #purolator_small_registered_account_number, #purolator_small_registered_city, #purolator_small_registered_state, #purolator_small_registered_zip, #purolator_small_pro_key, #purolator_small_pro_key_pass, #purolator_small_licence_key').removeClass('purolator_small_test_conn_prosessing');
                            jQuery('.purolator_small_warning_message').before('<div class="notice notice-error purolator_small_error_message"><p><strong>Error! ' + data['Error'] + '</strong></p></div>');
                        } else {
                            jQuery(".updated").hide();
                            jQuery('#purolator_small_billing_account_number, #purolator_small_registered_account_number, #purolator_small_registered_city, #purolator_small_registered_state, #purolator_small_registered_zip, #purolator_small_pro_key, #purolator_small_pro_key_pass, #purolator_small_licence_key').removeClass('purolator_small_test_conn_prosessing');
                            jQuery(".purolator_small_success_message").remove();
                            jQuery(".purolator_small_error_message").remove();
                            jQuery('.purolator_small_warning_message').before('<div class="notice notice-success purolator_small_success_message"><p><strong>Success! The test resulted in a successful connection.</strong></p></div>');

                        }
                    }

                });
                e.preventDefault();
            })

    </script>
    <?php
}
