    /*  =======================================
            Warehouse Section Script Start
        =======================================
    */


    /*
     * New Warehouse Save Function
     */
    
        function purolator_small_save_warehouse()
        {
            var city     = jQuery( '#purolator_small_origin_city' ).val();

            var zip_err     = false;
            var city_err    = false;
            var state_err   = false;
            var country_err = false;
            if ( jQuery( '#purolator_small_origin_zip' ).val() === '' )
            {
                jQuery( '.zip_invalid' ).hide();
                jQuery( '.purolator_small_zip_validation_err' ).remove();
                jQuery( '#purolator_small_origin_zip' ).after( '<span class="purolator_small_zip_validation_err">Zip is required.</span>' );
                zip_err = 1; 
            }

            if ( city === '')
            {
                jQuery( '.purolator_small_city_validation_err' ).remove();
                jQuery( '#purolator_small_origin_city' ).after( '<span class="purolator_small_city_validation_err">City is required.</span>' );
                city_err = 1;
            }

            if ( jQuery('#purolator_small_origin_state' ).val() === '' )
            {
                jQuery( '.purolator_small_state_validation_err' ).remove();
                jQuery( '#purolator_small_origin_state' ).after( '<span class="purolator_small_state_validation_err">State is required.</span>' );
                state_err = 1;
            }

            if ( jQuery('#purolator_small_origin_country' ).val() === '' )
            {
                jQuery( '.purolator_small_country_validation_err' ).remove();
                jQuery( '#purolator_small_origin_country' ).after( '<span class="purolator_small_country_validation_err">Country is required.</span>' );
                country_err = 1;
            }

            if ( zip_err || city_err || state_err || country_err ) {
                return false;
            }

           var postForm = {
                'action'                : 'purolator_small_save_warehouse',
                'origin_id'             : jQuery( '#edit_form_id' ).val(),
                'origin_city'           : city,
                'origin_state'          : jQuery( '#purolator_small_origin_state' ).val(),
                'origin_zip'            : jQuery( '#purolator_small_origin_zip' ).val(),
                'origin_country'        : jQuery( '#purolator_small_origin_country' ).val(),
                'location'              : jQuery( '#purolator_small_location' ).val(),
            };

            jQuery.ajax({
                type        : 'POST', 
                url         : ajaxurl, 
                data        : postForm, 
                dataType    : 'json',

                success: function ( data ) 
                {
                    console.log(data);
                    var WarehpuseDataId = data.id;
                    /*
                     * Append New Warehouse Row
                     */
                    if (data.insert_qry == 1) {
                        jQuery( '.warehouse_created' ).show( 'slow' ).delay(5000).hide('slow');
                        jQuery( '.warehouse_updated' ).css( 'display' , 'none' );
                        jQuery( '.warehouse_deleted' ).css( 'display' , 'none' );
                        jQuery( '.dropship_deleted' ).css( 'display' , 'none' );
                        jQuery( '.dropship_updated' ).css( 'display' , 'none' );
                        jQuery( '.dropship_created' ).css( 'display' , 'none' );
                        window.location.href = jQuery( '.close' ).attr( 'href' );
                        jQuery( '#append_warehouse tr:last' ).after( '<tr class="new_warehouse_add" id="row_'+WarehpuseDataId+'" data-id="'+WarehpuseDataId+'"><td class="purolator_small_warehouse_list_data">'+data.origin_city+'</td><td class="purolator_small_warehouse_list_data">'+data.origin_state+'</td><td class="purolator_small_warehouse_list_data">'+data.origin_zip+'</td><td class="purolator_small_warehouse_list_data">'+data.origin_country+'</td><td class="purolator_small_warehouse_list_data"><a href="javascript(0)" title="Edit" onclick="return purolator_small_edit_warehouse('+ WarehpuseDataId +')"><img src="'+script.pluginsUrl+'/small-package-quotes-purolator-edition/asset/edit.png"></a>  <a href="javascript(0)" title="Delete" onclick="return purolator_small_delete_current_warehouse('+ WarehpuseDataId +');"><img src="'+script.pluginsUrl+'/small-package-quotes-purolator-edition/asset/delete.png"></a></td></tr>' );
                    }
                    
                    /*
                     * Updated Existed Warehouse Row
                     */
                    
                    else if( data.update_qry == 1 ) {
                        jQuery( '.warehouse_updated' ).show( 'slow' ).delay(5000).hide('slow');
                        jQuery( '.warehouse_created' ).css( 'display' , 'none' );
                        jQuery( '.warehouse_deleted' ).css( 'display' , 'none' );
                        jQuery( '.dropship_deleted' ).css( 'display' , 'none' );
                        jQuery( '.dropship_updated' ).css( 'display' , 'none' );
                        jQuery( '.dropship_created' ).css( 'display' , 'none' );
                        window.location.href = jQuery( '.close' ).attr( 'href' );
                        jQuery( 'tr[id=row_'+WarehpuseDataId+']' ).html( '<td class="purolator_small_warehouse_list_data">'+data.origin_city+'</td><td class="purolator_small_warehouse_list_data">'+data.origin_state+'</td><td class="purolator_small_warehouse_list_data">'+data.origin_zip+'</td><td class="purolator_small_warehouse_list_data">'+data.origin_country+'</td><td class="purolator_small_warehouse_list_data"><a href="javascript(0)" title="Edit" onclick="return purolator_small_edit_warehouse('+ WarehpuseDataId +')"><img src="'+script.pluginsUrl+'/small-package-quotes-purolator-edition/asset/edit.png"></a><a href="javascript(0)" title="Delete" onclick="return purolator_small_delete_current_warehouse('+ WarehpuseDataId +');"><img src="'+script.pluginsUrl+'/small-package-quotes-purolator-edition/asset/delete.png"></a></td>' );
                    }
                    
                    else if( data == false ) {
                            jQuery( '.warehouse_invalid_input_message' ).show( 'slow' );
                        setTimeout( function () {
                                jQuery( '.warehouse_invalid_input_message' ).hide( 'slow' );
                            }, 5000);
                    }
                    /*
                     * Error Msg If Warehouse Already Exist
                     */
                    
                    else{
                        jQuery( '.already_exist' ).show( 'slow' );
                        setTimeout( function () {
                                jQuery( '.already_exist' ).hide( 'slow' );
                            }, 5000 );
                    }
                },
            }); return false;
        }

    /*
     * Delete Selected Warehouse Function
     */
   
        function purolator_small_delete_current_warehouse( e )
        {
            var postForm = {
                'action'    : 'purolator_small_delete_warehouse',
                'delete_id' : e,
            };
            jQuery.ajax({
                type    : 'POST', 
                url     : ajaxurl, 
                data    : postForm, 
                dataType: 'json',

                success: function (data) 
                {
                    /*
                     * Remove Warehouse Row
                     */
                    if (data == 1) {
                        jQuery( '#row_'+e ).remove();
                        jQuery( '.warehouse_deleted' ).show( 'slow' ).delay(5000).hide('slow');
                        jQuery( '.warehouse_updated' ).css( 'display' , 'none' );
                        jQuery( '.warehouse_created' ).css( 'display' , 'none' );
                        jQuery( '.dropship_deleted' ).css( 'display' , 'none' );
                        jQuery( '.dropship_updated' ).css( 'display' , 'none' );
                        jQuery( '.dropship_created' ).css( 'display' , 'none' );
                    }
                },
            }); return false;
        }
    
    /*
     * Edit Warehouse Row
     */
    
        function purolator_small_edit_warehouse( e )
        {
            jQuery( '.purolator_small_zip_validation_err' ).hide();
            jQuery( '.purolator_small_city_validation_err' ).hide();
            jQuery( '.purolator_small_state_validation_err' ).hide();
            jQuery( '.purolator_small_country_validation_err' ).hide();
                
            var postForm = {
                'action'    : 'purolator_small_edit_warehouse',
                'edit_id'   : e,
            };
            jQuery.ajax({
                type    : 'POST', 
                url     : ajaxurl, 
                data    : postForm, 
                dataType: 'json',

                success: function (data) 
                {   
                    /*
                     * Popup With Row Data
                     * Data Shows In Input Fields
                     */
                    if (data[0]) {
                        jQuery( '#edit_form_id' ).val( data[0].id );
                        jQuery( '#purolator_small_origin_zip' ).val( data[0].zip );
                        jQuery( '.city_select' ).hide();
                        jQuery( '.city_input' ).show();
                        jQuery( '#purolator_small_origin_city' ).val( data[0].city );
                        jQuery( '#purolator_small_origin_city' ).css('background', 'none');
                        jQuery( '#purolator_small_origin_state' ).val( data[0].state );
                        jQuery( '#purolator_small_origin_country' ).val( data[0].country );
                        jQuery( '.purolator_small_zip_validation_err , .purolator_small_city_validation_err, purolator_small_state_validation_err, purolator_small_country_validation_err' ).hide();
                        window.location.href = jQuery( '.purolator_small_add_warehouse_btn' ).attr( 'href'  );
                        jQuery( '.already_exist' ).hide();
                        setTimeout(function(){
                            if( jQuery( '.purolator_small_add_warehouse_popup' ).is( ':visible' ) ) {
                              jQuery( '.purolator_small_add_warehouse_input > input' ).eq( 0  ).focus();
                            }
                          },500 );
                    }
                },

            }); return false;
        }

    /*  =======================================
            Dropship Section Script Start
        =======================================
    */
    
    /*
     * New Drop Ship Save Function
     */
    
        function save_purolator_small_dropship()
        { 
            var city     = jQuery( '#purolator_small_dropship_city' ).val();

            var zip_err     = false;
            var city_err    = false;
            var state_err   = false;
            var country_err = false;
            if ( jQuery( '#purolator_small_dropship_zip' ).val() === '')
            {
                jQuery( '.purolator_small_zip_validation_err' ).remove();
                jQuery( '.zip_invalid' ).hide();
                jQuery( '#purolator_small_dropship_zip' ).after( '<span class="purolator_small_zip_validation_err">Zip is required.</span>' );
                zip_err = 1; 
            }

            if ( city === '')
            {
                jQuery( '.purolator_small_city_validation_err' ).remove();
                jQuery( '#purolator_small_dropship_city' ).after( '<span class="purolator_small_city_validation_err">City is required.</span>' );
                city_err = 1;
            }

            if ( jQuery( '#purolator_small_dropship_state' ).val() === '')
            {
                jQuery( '.purolator_small_state_validation_err' ).remove();
                jQuery( '#purolator_small_dropship_state' ).after( '<span class="purolator_small_state_validation_err">State is required.</span>' );
                state_err = 1;
            }

            if ( jQuery( '#purolator_small_dropship_country' ).val() === '')
            {
                jQuery( '.purolator_small_country_validation_err' ).remove();
                jQuery( '#purolator_small_dropship_country' ).after( '<span class="purolator_small_country_validation_err">Country is required.</span>' );
                country_err = 1;
            }

            if ( zip_err || city_err || state_err || country_err ) {
                return false;
            }

            var postForm = {
                'action'                : 'purolator_small_save_dropship',
                'dropship_id'             : jQuery( '#edit_dropship_form_id' ).val(),
                'dropship_city'           : city,
                'dropship_state'          : jQuery( '#purolator_small_dropship_state' ).val(),
                'dropship_zip'            : jQuery( '#purolator_small_dropship_zip' ).val(),
                'dropship_country'        : jQuery( '#purolator_small_dropship_country' ).val(),
                'nickname'                : jQuery( '#purolator_small_dropship_nickname' ).val(),
                'location'                : jQuery( '#purolator_small_dropship_location' ).val(),
            };

            jQuery.ajax({
                type: 'POST', 
                url: ajaxurl, 
                data: postForm, 
                dataType: 'json',

                success: function (data) 
                {
                    var WarehpuseDataId = data.id;
                    
                    /*
                     * Append New Drop Ship Row
                     */
                    
                    if (data.insert_qry == 1) {
                        jQuery( '.dropship_created' ).show( 'slow' ).delay(5000).hide('slow');
                        jQuery( '.dropship_updated' ).css( 'display' , 'none' );
                        jQuery( '.dropship_deleted' ).css( 'display' , 'none' );
                        jQuery( '.warehouse_deleted' ).css( 'display' , 'none' );
                        jQuery( '.warehouse_updated' ).css( 'display' , 'none' );
                        jQuery( '.warehouse_created' ).css( 'display' , 'none' );
                        window.location.href = jQuery( '.close' ).attr('href' );
                        jQuery( '#append_dropship tr:last' ).after( '<tr class="new_dropship_add" id="row_'+WarehpuseDataId+'" data-id="'+WarehpuseDataId+'"><td class="purolator_small_dropship_list_data">'+data.nickname+'</td><td class="purolator_small_dropship_list_data">'+data.origin_city+'</td><td class="purolator_small_dropship_list_data">'+data.origin_state+'</td><td class="purolator_small_dropship_list_data">'+data.origin_zip+'</td><td class="purolator_small_dropship_list_data">'+data.origin_country+'</td><td class="purolator_small_dropship_list_data"><a href="javascript(0)" title="Edit" onclick="return purolator_small_edit_dropship('+WarehpuseDataId+')"><img src="'+script.pluginsUrl+'/small-package-quotes-purolator-edition/asset/edit.png"></a>  <a href="javascript(0)" title="Delete" onclick="return purolator_small_delete_current_dropship('+ WarehpuseDataId +');"><img src="'+script.pluginsUrl+'/small-package-quotes-purolator-edition/asset/delete.png"></a></td></tr>' );
                    }
                    
                    /*
                     * Updated Existed Warehouse Row
                     */
                    
                    else if( data.update_qry == 1 ){
                        jQuery( '.dropship_updated' ).show( 'slow' ).delay(5000).hide('slow');
                        jQuery( '.dropship_created' ).css( 'display' , 'none' );
                        jQuery( '.dropship_deleted' ).css( 'display' , 'none' );
                        jQuery( '.warehouse_deleted' ).css( 'display' , 'none' );
                        jQuery( '.warehouse_updated' ).css( 'display' , 'none' );
                        jQuery( '.warehouse_created' ).css( 'display' , 'none' );
                        window.location.href = jQuery( '.close' ).attr( 'href' );
                        jQuery( 'tr[id=row_'+WarehpuseDataId+']' ).html( '<td class="purolator_small_dropship_list_data">'+data.nickname+'</td><td class="purolator_small_dropship_list_data">'+data.origin_city+'</td><td class="purolator_small_dropship_list_data">'+data.origin_state+'</td><td class="purolator_small_dropship_list_data">'+data.origin_zip+'</td><td class="purolator_small_dropship_list_data">'+data.origin_country+'</td><td class="purolator_small_dropship_list_data"><a href="javascript(0)" title="Edit" onclick="return purolator_small_edit_dropship('+WarehpuseDataId+')"><img src="'+script.pluginsUrl+'/small-package-quotes-purolator-edition/asset/edit.png"></a><a href="javascript(0)" title="Delete" onclick="return purolator_small_delete_current_dropship('+ WarehpuseDataId +');"><img src="'+script.pluginsUrl+'/small-package-quotes-purolator-edition/asset/delete.png"></a></td>' );
                    }
                    
                    else if( data == false ) {
                            jQuery( '.dropship_invalid_input_message' ).show( 'slow' );
                        setTimeout( function () {
                                jQuery( '.dropship_invalid_input_message' ).hide( 'slow' );
                            }, 5000);
                    }
                    
                    /*
                     * Error Msg If Warehouse Already Exist
                     */
                    
                    else{
                        jQuery( '.already_exist' ).show( 'slow' );
                        setTimeout( function () {
                                jQuery( '.already_exist' ).hide( 'slow' );
                            }, 5000 );
                    }
                },
            }); return false;
        }

    /*
     * Edit Drop Ship Row
     */

        function purolator_small_edit_dropship( e )
        {
            jQuery( '.purolator_small_zip_validation_err' ).hide();
            jQuery( '.purolator_small_city_validation_err' ).hide();
            jQuery( '.purolator_small_state_validation_err' ).hide();
            jQuery( '.purolator_small_country_validation_err' ).hide();

            var postForm = {
                'action'                : 'purolator_small_edit_dropship',
                'dropship_edit_id'      : e,
            };
            jQuery.ajax({
                type: 'POST', 
                url: ajaxurl, 
                data: postForm, 
                dataType: 'json',

                success: function ( data ) 
                {
                    /*
                     * Popup With Row Data
                     * Data Shows In Input Fields
                     */
                    if ( data[0] ) {
                        jQuery( '#edit_dropship_form_id' ).val( data[0].id );
                        jQuery( '#purolator_small_dropship_zip' ).val( data[0].zip );
                        jQuery( '#purolator_small_dropship_nickname' ).val( data[0].nickname );
                        jQuery( '.city_select' ).hide();
                        jQuery( '.city_input' ).show();
                        jQuery( '#purolator_small_dropship_city' ).val( data[0].city );
                        jQuery( '#purolator_small_dropship_city' ).css('background', 'none'); 
                        jQuery( '#purolator_small_dropship_state' ).val( data[0].state );
                        jQuery( '#purolator_small_dropship_country' ).val( data[0].country );
                        jQuery( '.purolator_small_zip_validation_err , .purolator_small_city_validation_err, purolator_small_state_validation_err, purolator_small_country_validation_err' ).hide();
                        window.location.href = jQuery('.purolator_small_add_dropship_btn').attr('href');
                        jQuery( '.already_exist' ).hide();
                        setTimeout(function(){
                            if(jQuery('.ds_popup').is(':visible')){
                              jQuery('.ds_input > input').eq(0).focus();
                            }
                          },500);
                    }
                },

            }); return false;
        }
    
    /*
     * Confirm Delete Drop Ship Popup
     */
    
        function purolator_small_delete_current_dropship( e )
        {
            var id = e;
            window.location.href = jQuery( '.purolator_small_delete_dropship_btn' ).attr( 'href' );
            jQuery( '.purolator_small_cancel_delete' ).on( 'click', function () {
                window.location.href = jQuery( '.purolator_small_cancel_delete' ).attr( 'href' );
            });
            jQuery( '.purolator_small_confirm_delete' ).on( 'click', function () {
                window.location.href = jQuery( '.purolator_small_confirm_delete' ).attr( 'href' );
                return confirm_purolator_small_delete_dropship( id );
            });
            return false;
        }
        
    /*
     * Delete Drop Ship Row
     */

        function confirm_purolator_small_delete_dropship( e )
        {
            var postForm = {
                'action'                : 'purolator_small_delete_dropship',
                'dropship_delete_id'    : e,
            };
            jQuery.ajax({
                type    : 'POST', 
                url     : ajaxurl, 
                data    : postForm, 
                dataType: 'json',

                success: function ( data ) 
                {
                    if ( data == 1 ) {
                        jQuery( '#row_'+e).remove();
                        jQuery( '.dropship_deleted' ).show( 'slow' ).delay(5000).hide('slow');
                        jQuery( '.dropship_updated' ).css( 'display' , 'none' );
                        jQuery( '.dropship_created' ).css( 'display' , 'none' );
                        jQuery( '.warehouse_deleted' ).css( 'display' , 'none' );
                        jQuery( '.warehouse_updated' ).css( 'display' , 'none' );
                        jQuery( '.warehouse_created' ).css( 'display' , 'none' );
                    }
                },

            }); return false;
        }