<?php
/**
 * Purolator Small curl response class | Curl response from api
 * @package     Woocommerce Purolator Small
 * @author      <https://eniture.com/>
 * @copyright   Copyright (c) 2017, Eniture
 */
    if ( ! defined( 'ABSPATH' ) ) {
        exit; 
    }
        
/**
 * Curl Response Class
 */ 
    class Purolator_Small_Curl_Request 
    {
        /**
         * Get Curl Response 
         * @param $url
         * @param $postData
         * @return json
         */
        
            function purolator_small_get_curl_response($url, $postData) 
            {
                if ( !empty( $url ) && !empty( $postData ) )
                {
                    $field_string = http_build_query($postData);
                    $ch = curl_init();
                    curl_setopt($ch, CURLOPT_URL, $url);
                    curl_setopt($ch, CURLOPT_POST, 1);
                    curl_setopt($ch, CURLOPT_POSTFIELDS, $field_string);
                    curl_setopt($ch, CURLOPT_HTTPHEADER, array('Expect:'));
                    curl_setopt($ch, CURLOPT_FAILONERROR, 1);
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                    $output = curl_exec($ch);
                    curl_close($ch);
                    return $output;
                }    
            }
    }