<?php
/**
 * Distance Request
 * @package     Woocommerce Purolator Small
 * @author      <https://eniture.com/>
 * @copyright   Copyright (c) 2017, Eniture
 */
if ( ! defined( 'ABSPATH' ) ) {
    exit; 
}
    
/**
 * Distance Request Class
 */

    class Get_purolator_small_distance {
        
        /**
         * Get Address Upon Access Level
         * @param $map_address
         * @param $accessLevel
         * @return array
         */
        
            function purolator_small_address($map_address, $accessLevel, $destinationZip = array()) {
                $post = array(
                    'dontAuth'          => 1,
                    'acessLevel'        => $accessLevel,
                    'address'           => $map_address,
                    'originAddresses'   => (isset($map_address)) ? $map_address : "",
                    'destinationAddress'=> (isset($destinationZip)) ? $destinationZip : "",
                    'eniureLicenceKey'  => get_option('purolator_small_licence_key'),
                    'ServerName'        => $_SERVER['SERVER_NAME'],
                );                
                $purolator_small_curl_obj = new Purolator_Small_Curl_Request();
                $output   = $purolator_small_curl_obj->purolator_small_get_curl_response('http://eniture-dev.com/ws/addon/google-location.php', $post);
                return $output;
            }
    }
